#include <stdio.h>
#include "SDL.h"

const Uint8 pcxpal[] = /* [1..PCXnum] */
{ 0, 7, 5, 8, 10, 5, 18, 19, 19, 20, 21, 22, 5};

SDL_Color palettes[100][256];

void JE_loadPals( void )
{
	FILE *f;
	int i;

	int palNum = 0;

	f = fopen("palette.dat", "rb");
	while (palNum < 100)
	{
		for (i = 0; i < 256; i++)
		{
			palettes[palNum][i].r = getc(f) << 2;
			palettes[palNum][i].g = getc(f) << 2;
			palettes[palNum][i].b = getc(f) << 2;
		}
		palNum++;
	}
	fclose(f);
}

int main( int argc, char *argv[] )
{
	JE_loadPals();
	
	SDL_Surface *VGAScreen = SDL_SetVideoMode(320, 200, 8, SDL_SWSURFACE | SDL_HWPALETTE);
	
	FILE *PCXfile = fopen("tyrian.pic", "rb");
	
	Uint32 pcxpos[100];
	Uint16 x;
	
	fread(&x, sizeof(Uint16), 1, PCXfile);
	for (int i = 0; i < x; i++)
	{
		fread(&pcxpos[i], sizeof(Uint32), 1, PCXfile);
	}
	fseek(PCXfile, 0, SEEK_END);
	pcxpos[x] = ftell(PCXfile);
	
	for (int PCXnumber = 0; PCXnumber < x; PCXnumber++)
	{
		Uint8 buf[63000];

		Uint8 *p;
		Uint8 *s; /* screen pointer, 8-bit specific */

		s = (Uint8 *)VGAScreen->pixels;

		fseek(PCXfile, pcxpos[PCXnumber], SEEK_SET);
		fread(buf, sizeof(Uint8), pcxpos[PCXnumber + 1] - pcxpos[PCXnumber], PCXfile);

		p = (Uint8 *)buf;
		for (int i = 0; i < 320 * 200; )
		{
			if ((*p & 0xc0) == 0xc0)
			{
				i += (*p & 0x3f);
				memset(s, *(p + 1), (*p & 0x3f));
				s += (*p & 0x3f); p += 2;
			} else {
				i++;
				*s = *p;
				s++; p++;
			}
			if (i && (i % 320 == 0))
			{
				s += VGAScreen->pitch - 320;
			}
		}
		
		SDL_SetColors(VGAScreen, palettes[pcxpal[PCXnumber]], 0, 256);
		
		SDL_Flip(VGAScreen);
		
		char foo[100];
		sprintf(foo, "tyrian.pic-%02d.bmp", PCXnumber);
		SDL_SaveBMP(VGAScreen, foo);
		
		SDL_Delay(500);
	}
	
	return 0;
}
